<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { computed, inject, onMounted, ref } from 'vue';
import { useI18n } from 'vue-i18n';
import QRCodeStyling from 'qr-code-styling';
import Modal from '@/components/general/Modal.vue';
import { useBaseStore } from '@/stores/base';
import Button from "@/components/general/Button.vue";
import { request } from '@/lib/request';
import Input from "@/components/general/form/Input.vue";
import RadioButtonsGroup from "@/components/general/form/RadioButtonsGroup.vue";
const { t } = useI18n();
const $t = t;

const props = defineProps<{
    uuid: string,
    type: string,
    title: string
}>();

const emits = defineEmits<{
    (e: 'close'): void
}>();
const baseStore = useBaseStore();
const { message, status } = storeToRefs(baseStore);
let configuration = inject<any>('configuration');
const baseURL = configuration.baseURL;
const basePath = configuration.basePath;
const qrstyling = configuration.style.qrcode;

const currentUrl = ref(baseURL + basePath + "chat/" + props.uuid);
const qrcodeColors = qrstyling;
const src = currentUrl.value;
const iframe = "<iframe frameborder='0' src='" + src + "' style='width:100%;height:600px;padding:0;margin:0;'></iframe>";

const handleCopyCode = () => {
    navigator.clipboard.writeText(iframe).then(() => {
        message.value = $t('adminMenu.pageShare.copy.success.html');
    }).catch((e) => { console.error(e) });
};

const handleCloseModal = () => {
    emits('close');
};
const isShared = ref(false);
const localValidUrl = ref('');
const validUntil = computed({
    get: () => {
        return localValidUrl.value;
    },
    set: (value: string) => {
        localValidUrl.value = value;
        showDateError.value = +new Date(value) > +new Date(maxDate.value);
    }
});
const showDateError = ref(false);

const sharedMaxDate = ref();
const maxDate = computed(() => {
    if(sharedMaxDate.value){
        const date = new Date(sharedMaxDate.value);
        return getFormatedDate(date);

    }else{
        const today = new Date();
        const date = new Date(today.setDate(today.getDate() + 14));
        return getFormatedDate(date);
    }
});
const getFormatedDate = (date: Date) => {
    const year = date.getFullYear();
    const month = ('0' + (date.getMonth() + 1)).slice(-2);
    const day = ('0' + date.getDate()).slice(-2);
    const hours = ('0' + date.getHours()).slice(-2);
    const minutes = ('0' + date.getMinutes()).slice(-2);
    return `${year}-${month}-${day}T${hours}:${minutes}`;
};

const qrcodeRef = ref();
const canShare = ref(true);
onMounted(async () => {
    const result = await request('GET', configuration.apiServer + "/api/ai/chat/" + props.uuid + "/share", undefined, 'application/json', undefined, true);
    if (result && !result.success) {
        isShared.value = false;
        const date = new Date();
        const newDate = new Date(date.setHours(date.getHours()+1));
        validUntil.value = getFormatedDate(newDate);
    }
    else {
        if (result.canShare !== undefined && !result.canShare) {
            canShare.value = false;
        }
        else {
            isShared.value = true;
            validUntil.value = result.validUntil;
            if(result.createdAt){
                const date = new Date(result.createdAt);
                date.setDate(date.getDate() + 14);
                sharedMaxDate.value = date;
            }
            limitation.value = result.limitation > -1 ? result.limitation : $t('ai.general.variables.unlimited.label');
            renderQRCode(currentUrl.value);
        }
    }
});



const renderQRCode = (url: string) => {
    setTimeout(async () => {
        const options = {
            width: 250,
            height: 250,
            type: 'canvas',
            data: url,
            image: basePath + 'images/logo_qr.png',
            margin: 10,
            qrOptions: {
                typeNumber: 0,
                mode: 'Byte',
                errorCorrectionLevel: 'Q'
            },
            imageOptions: {
                hideBackgroundDots: false,
                imageSize: 0.4,
                margin: 5,
                crossOrigin: 'anonymous',
            },
            dotsOptions: {
                color: qrcodeColors.dots,
                type: 'rounded'
            },
            backgroundOptions: {
                color: qrcodeColors.background,
            },
            cornersSquareOptions: {
                color: qrcodeColors.cornersSquare,
                type: 'extra-rounded',
            },
            cornersDotOptions: {
                color: qrcodeColors.cornersDot,
                //type: 'none',
            }
        };
        qrcodeRef.value.innerHTML = null;
        //@ts-ignore
        const qrCode = new QRCodeStyling(options);
        qrCode.append(qrcodeRef.value);
    }, 1);
}

const handleSubmit = async () => {
    const data = { validUntil: validUntil.value, limitation: limitation.value };
    const result = await request('PUT', configuration.apiServer + "/api/ai/chat/" + props.uuid + "/share", data, 'application/json', undefined, true);
    if (result.success) {
        isShared.value = true;
        renderQRCode(currentUrl.value);
    }
};

const chatTokenLimitations = configuration.ai.limitations.chat.map((limit: number) => { return { label: $t('ai.general.variables.tokens.label', [limit]), name: limit }; });
const imageGenLimitations = configuration.ai.limitations.image.map((limit: number) => { return { label: $t('ai.general.variables.images.label', [limit]), name: limit }; });

const localLimitations = computed(() => {
    if (props.type === 'image') return imageGenLimitations;
    else return chatTokenLimitations;
});
const limitation = ref(localLimitations.value[0].name);

const handleUnshare = async () => {
    if (canShare.value) {
        const result = await request('DELETE', configuration.apiServer + "/api/ai/chat/" + props.uuid + "/share", undefined, 'application/json', undefined, true);
        if (result.success) {
            emits('close');
        }
    } else {
        const result = await request('DELETE', configuration.apiServer + "/api/ai/chat/" + props.uuid + "/share?chats=true", undefined, 'application/json', undefined, true);
        if (result.success) {
            message.value = $t('ai.general.share.notification.deleteChatMessages');
            emits('close');
        }
    }
};

const tokens = ref<number>(-1);
const showEditTokens = ref(false);
const handleEditTokens = () => {
    showEditTokens.value = true;
    tokens.value = typeof (limitation.value) === 'number' ? limitation.value : -1;
};

const handleSubmitEditTokens = async () => {
    const data = { limitation: tokens.value };
    const result = await request('POST', configuration.apiServer + "/api/ai/chat/" + props.uuid + "/share", data, 'application/json', undefined, true);
    if (result.success) {
        limitation.value = tokens.value > -1 ? tokens.value : $t('ai.general.variables.unlimited.label');
        handleCancelEditTokens();
    }

};

const handleCancelEditTokens = () => {
    tokens.value = -1;
    showEditTokens.value = false;
};

const showEditDate = ref(false);
const date = ref<string>("");
const handleEditDate = ()=>{
    showEditDate.value = true;
    date.value = validUntil.value;
};

const handleSubmitEditDate = async()=>{
    const data = { validUntil: date.value };
    const result = await request('POST', configuration.apiServer + "/api/ai/chat/" + props.uuid + "/share", data, 'application/json', undefined, true);
    if (result.success) {
        validUntil.value = date.value;
        handleCancelEditDate();
    }
};

const handleCancelEditDate = () => {
    date.value = "";
    showEditDate.value = false;
};

</script>
<template>
    <Modal :header="$t('ai.chat.share.modal.header')" :labelCancel="$t('general.buttons.close')"
        :labelSubmit="!isShared && canShare ? $t('adminMenu.copy.forOthers.share.label') : undefined"
        :iconLeft="isShared && canShare ? 'true' : !canShare ? 'true' : undefined"
        iconLeftColor="text-red-700 hover:text-red-800"
        :tooltipLeft="isShared && canShare ? $t('ai.general.share.unshare.label') : !canShare ? $t('ai.general.share.deleteChats.label') : undefined"
        :disableSubmit="showDateError" @submit="handleSubmit" @cancel="handleCloseModal" @left="handleUnshare">
        <template #iconLeft v-if="canShare"><i class="ri-stop-circle-line ri-xl mr-1"></i>{{
            $t('ai.general.share.unshare.label') }}</template>
        <template #iconLeft v-else><i class="ri-delete-bin-line ri-xl mr-1"></i>{{
            $t('ai.general.share.unshare.deleteMessages.tooltip') }}</template>
        <div v-if="canShare">
            <div v-if="!isShared">
                <Input :label="$t('ai.general.share.until.label')" type="datetime-local" v-model="validUntil"
                    :max="maxDate" :errorText="showDateError ? $t('ai.general.share.until.error') : undefined" />
                <RadioButtonsGroup :label="$t('ai.general.share.limitation.label')" v-model="limitation" :info="$t('ai.general.share.limitation.tooltip')"
                    :items="localLimitations" columns />

            </div>
            <div v-else>
                <h4 class="text-lg line-clamp-1">{{ title }}</h4>
                <div class="flex flex-row gap-2">
                    <div>
                        <div class="z-[2000]" id="qrcode" ref="qrcodeRef"></div>
                    </div>
                    <div class="w-full sm:w-1/2">
                        <h4 class="mt-2 text-lg">{{ $t('ai.chat.share.modal.url.label') }}</h4>
                        <h5 class="text-gray-500 break-all">{{ currentUrl }}</h5>
                        <h4 class="mt-2 text-lg">{{ $t('ai.general.share.until.label') }}</h4>
                        <h5 class="text-gray-500 break-all flex flex-row gap-2" v-if="!showEditDate">{{ new Date(validUntil).toLocaleString() }} <Tooltip :tooltip="$t('contentPage.editLabel')">
                                <button class="rounded-full hover:bg-gray-100 w-5 h-5" @click="handleEditDate"><i
                                        class="ri-pencil-line"></i></button>
                            </Tooltip></h5>
                        <div v-else class="flex flex-row gap-2">
                            <Input type="datetime-local" v-model="date"
                                :max="maxDate" :errorText="showDateError ? $t('ai.general.share.until.error') : undefined" />
                            <button class="bg-red-500 size-6 min-w-6 rounded-full text-white hover:bg-red-600 mt-1"
                                @click="handleCancelEditDate"><i class="ri-close-line"></i></button>
                            <button class="bg-green-500 size-6 min-w-6 rounded-full text-white hover:bg-green-600 mt-1"
                                @click="handleSubmitEditDate"><i class="ri-check-line"></i></button>
                        </div>
                        <h4 class="flex flex-row gap-1 mt-4 text-lg">{{ $t('ai.general.share.limitation.label') }}:</h4>
                        <h5 class="text-gray-500 break-all flex flex-row gap-2" v-if="!showEditTokens">{{
                            props.type === 'image' ? $t('ai.general.variables.images.label',
                                [limitation]) : $t('ai.general.variables.tokens.label', [limitation]) }}
                            <Tooltip :tooltip="$t('contentPage.editLabel')">
                                <button class="rounded-full hover:bg-gray-100 w-5 h-5" @click="handleEditTokens"><i
                                        class="ri-pencil-line"></i></button>
                            </Tooltip>
                        </h5>
                        <div v-else class="flex flex-row gap-2">
                            <select
                                class="w-full border border-gray-300 px-2 py-1.5 focus:border-accent1-default rounded-md focus-visible:outline-0 h-8"
                                v-model="tokens">
                                <option :key="index" v-for="element, index in localLimitations" :value="element.name">{{
                                    element.label }}</option>
                            </select>
                            <button class="bg-red-500 size-6 min-w-6 rounded-full text-white hover:bg-red-600 mt-1"
                                @click="handleCancelEditTokens"><i class="ri-close-line"></i></button>
                            <button class="bg-green-500 size-6 min-w-6 rounded-full text-white hover:bg-green-600 mt-1"
                                @click="handleSubmitEditTokens"><i class="ri-check-line"></i></button>
                        </div>
                    </div>
                </div>
                <pre
                    class="mb-2 whitespace-pre-line p-3 bg-white overflow-auto text-gray-700 font-mono border border-gray-300">
            <code class="whitespace-pre-wrap">{{ iframe }}</code>
        </pre>
                <Button variant="confirm" @click="handleCopyCode">
                    <i class="ri-file-copy-line"></i>
                    <span class="ml-2">{{ $t('adminMenu.pageShare.copy.label') }}</span>
                </Button>
            </div>
        </div>
        <div v-else v-html="$t('ai.general.share.unshare.deleteMessages.description')"></div>
    </Modal>
</template>
